Index: ecos/packages/io/serial/current/src/common/termiostty.c
===================================================================
RCS file: /cvs/ecos/ecos/packages/io/serial/current/src/common/termiostty.c,v
retrieving revision 1.6
diff -u -5 -p -r1.6 termiostty.c
--- ecos/packages/io/serial/current/src/common/termiostty.c	5 Sep 2003 05:09:19 -0000	1.6
+++ ecos/packages/io/serial/current/src/common/termiostty.c	18 Jul 2005 16:31:37 -0000
@@ -254,11 +254,12 @@ real_termios_init( struct termios_privat
         res = cyg_io_get_config( priv->dev_handle,
                                  CYG_IO_GET_CONFIG_SERIAL_BUFFER_INFO,
                                  &dev_buf_conf, &len );
     }
 
-    priv->errbuf = (cyg_uint8 *)malloc( dev_buf_conf.rx_bufsize );
+    if ( NULL == priv->errbuf )  // Re-entrant code -- only do this once!
+        priv->errbuf = (cyg_uint8 *)malloc( dev_buf_conf.rx_bufsize );
     if ( NULL == priv->errbuf )
         res = ENOMEM;   // FIXME: Are we allowed to do this?
     priv->errbufpos = priv->errbuf;
     priv->errbufsize = dev_buf_conf.rx_bufsize;
 

